using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Reflection;
using System.Windows.Forms;
using System.Security.Cryptography;
using PvLogiciels.dotNetProtector;
using System.Threading;

namespace Wizard
{
	/// <summary>
	/// Description rsume de WizardKey.
	/// </summary>
	internal class WizardKey : System.Windows.Forms.Form
	{
		public int wzAction;
        public string ProductKey;

        public System.Windows.Forms.Label label1;
		public KeyEditBox Key1;
		private System.Windows.Forms.Button Suivant;
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;
		public static string Base32 = "0123456789ACDEFGHJKLMNPQRTUVWXYZ";
		private System.Windows.Forms.Label label2;
        private TextBox tbMessage;
		private System.Windows.Forms.Button button1;
        private Thread theThread;
        private Label lblLicense;
        private Button Precedent;

        delegate void ShowLicenseDelegate(uint id, ulong data);


		public WizardKey()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();
            Key1.MaxLength = 29;
            Text = Program.WizardTitle;

            Suivant.Enabled = false;
            tbMessage.Text = "";
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(WizardKey));
            this.label1 = new System.Windows.Forms.Label();
            this.Suivant = new System.Windows.Forms.Button();
            this.label2 = new System.Windows.Forms.Label();
            this.button1 = new System.Windows.Forms.Button();
            this.tbMessage = new System.Windows.Forms.TextBox();
            this.lblLicense = new System.Windows.Forms.Label();
            this.Precedent = new System.Windows.Forms.Button();
            this.Key1 = new Wizard.KeyEditBox();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.AccessibleDescription = null;
            this.label1.AccessibleName = null;
            resources.ApplyResources(this.label1, "label1");
            this.label1.Name = "label1";
            // 
            // Suivant
            // 
            this.Suivant.AccessibleDescription = null;
            this.Suivant.AccessibleName = null;
            resources.ApplyResources(this.Suivant, "Suivant");
            this.Suivant.BackgroundImage = null;
            this.Suivant.Font = null;
            this.Suivant.Name = "Suivant";
            this.Suivant.Click += new System.EventHandler(this.Suivant_Click);
            // 
            // label2
            // 
            this.label2.AccessibleDescription = null;
            this.label2.AccessibleName = null;
            resources.ApplyResources(this.label2, "label2");
            this.label2.Name = "label2";
            // 
            // button1
            // 
            this.button1.AccessibleDescription = null;
            this.button1.AccessibleName = null;
            resources.ApplyResources(this.button1, "button1");
            this.button1.BackgroundImage = null;
            this.button1.Font = null;
            this.button1.Name = "button1";
            this.button1.Click += new System.EventHandler(this.button1_Click);
            // 
            // tbMessage
            // 
            this.tbMessage.AccessibleDescription = null;
            this.tbMessage.AccessibleName = null;
            resources.ApplyResources(this.tbMessage, "tbMessage");
            this.tbMessage.BackgroundImage = null;
            this.tbMessage.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.tbMessage.Name = "tbMessage";
            this.tbMessage.ReadOnly = true;
            this.tbMessage.TabStop = false;
            // 
            // lblLicense
            // 
            this.lblLicense.AccessibleDescription = null;
            this.lblLicense.AccessibleName = null;
            resources.ApplyResources(this.lblLicense, "lblLicense");
            this.lblLicense.Font = null;
            this.lblLicense.Name = "lblLicense";
            // 
            // Precedent
            // 
            this.Precedent.AccessibleDescription = null;
            this.Precedent.AccessibleName = null;
            resources.ApplyResources(this.Precedent, "Precedent");
            this.Precedent.BackgroundImage = null;
            this.Precedent.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.Precedent.Font = null;
            this.Precedent.Name = "Precedent";
            this.Precedent.Click += new System.EventHandler(this.Precedent_Click_1);
            // 
            // Key1
            // 
            this.Key1.AccessibleDescription = null;
            this.Key1.AccessibleName = null;
            resources.ApplyResources(this.Key1, "Key1");
            this.Key1.BackgroundImage = null;
            this.Key1.Font = null;
            this.Key1.Name = "Key1";
            this.Key1.TextChanged += new System.EventHandler(this.Key_TextChanged);
            // 
            // WizardKey
            // 
            this.AccessibleDescription = null;
            this.AccessibleName = null;
            resources.ApplyResources(this, "$this");
            this.BackgroundImage = null;
            this.Controls.Add(this.Precedent);
            this.Controls.Add(this.lblLicense);
            this.Controls.Add(this.tbMessage);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.Suivant);
            this.Controls.Add(this.Key1);
            this.Controls.Add(this.label1);
            this.Font = null;
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = null;
            this.KeyPreview = true;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "WizardKey";
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void Precedent_Click(object sender, System.EventArgs e)
        {

        }


        static uint[] crc_table = {
	        0x00000000, 0xEDB88320, 0x36C98560, 0xDB710640, 0x6D930AC0, 0x802B89E0, 0x5B5A8FA0, 0xB6E20C80, 0xDB261580, 0x369E96A0, 0xEDEF90E0, 0x005713C0, 0xB6B51F40, 0x5B0D9C60, 0x807C9A20, 0x6DC41900,
	        0x5BF4A820, 0xB64C2B00, 0x6D3D2D40, 0x8085AE60, 0x3667A2E0, 0xDBDF21C0, 0x00AE2780, 0xED16A4A0, 0x80D2BDA0, 0x6D6A3E80, 0xB61B38C0, 0x5BA3BBE0, 0xED41B760, 0x00F93440, 0xDB883200, 0x3630B120,
	        0xB7E95040, 0x5A51D360, 0x8120D520, 0x6C985600, 0xDA7A5A80, 0x37C2D9A0, 0xECB3DFE0, 0x010B5CC0, 0x6CCF45C0, 0x8177C6E0, 0x5A06C0A0, 0xB7BE4380, 0x015C4F00, 0xECE4CC20, 0x3795CA60, 0xDA2D4940,
	        0xEC1DF860, 0x01A57B40, 0xDAD47D00, 0x376CFE20, 0x818EF2A0, 0x6C367180, 0xB74777C0, 0x5AFFF4E0, 0x373BEDE0, 0xDA836EC0, 0x01F26880, 0xEC4AEBA0, 0x5AA8E720, 0xB7106400, 0x6C616240, 0x81D9E160,
	        0x826A23A0, 0x6FD2A080, 0xB4A3A6C0, 0x591B25E0, 0xEFF92960, 0x0241AA40, 0xD930AC00, 0x34882F20, 0x594C3620, 0xB4F4B500, 0x6F85B340, 0x823D3060, 0x34DF3CE0, 0xD967BFC0, 0x0216B980, 0xEFAE3AA0,
	        0xD99E8B80, 0x342608A0, 0xEF570EE0, 0x02EF8DC0, 0xB40D8140, 0x59B50260, 0x82C40420, 0x6F7C8700, 0x02B89E00, 0xEF001D20, 0x34711B60, 0xD9C99840, 0x6F2B94C0, 0x829317E0, 0x59E211A0, 0xB45A9280,
	        0x358373E0, 0xD83BF0C0, 0x034AF680, 0xEEF275A0, 0x58107920, 0xB5A8FA00, 0x6ED9FC40, 0x83617F60, 0xEEA56660, 0x031DE540, 0xD86CE300, 0x35D46020, 0x83366CA0, 0x6E8EEF80, 0xB5FFE9C0, 0x58476AE0,
	        0x6E77DBC0, 0x83CF58E0, 0x58BE5EA0, 0xB506DD80, 0x03E4D100, 0xEE5C5220, 0x352D5460, 0xD895D740, 0xB551CE40, 0x58E94D60, 0x83984B20, 0x6E20C800, 0xD8C2C480, 0x357A47A0, 0xEE0B41E0, 0x03B3C2C0,
	        0xE96CC460, 0x04D44740, 0xDFA54100, 0x321DC220, 0x84FFCEA0, 0x69474D80, 0xB2364BC0, 0x5F8EC8E0, 0x324AD1E0, 0xDFF252C0, 0x04835480, 0xE93BD7A0, 0x5FD9DB20, 0xB2615800, 0x69105E40, 0x84A8DD60,
	        0xB2986C40, 0x5F20EF60, 0x8451E920, 0x69E96A00, 0xDF0B6680, 0x32B3E5A0, 0xE9C2E3E0, 0x047A60C0, 0x69BE79C0, 0x8406FAE0, 0x5F77FCA0, 0xB2CF7F80, 0x042D7300, 0xE995F020, 0x32E4F660, 0xDF5C7540,
	        0x5E859420, 0xB33D1700, 0x684C1140, 0x85F49260, 0x33169EE0, 0xDEAE1DC0, 0x05DF1B80, 0xE86798A0, 0x85A381A0, 0x681B0280, 0xB36A04C0, 0x5ED287E0, 0xE8308B60, 0x05880840, 0xDEF90E00, 0x33418D20,
	        0x05713C00, 0xE8C9BF20, 0x33B8B960, 0xDE003A40, 0x68E236C0, 0x855AB5E0, 0x5E2BB3A0, 0xB3933080, 0xDE572980, 0x33EFAAA0, 0xE89EACE0, 0x05262FC0, 0xB3C42340, 0x5E7CA060, 0x850DA620, 0x68B52500,
	        0x6B06E7C0, 0x86BE64E0, 0x5DCF62A0, 0xB077E180, 0x0695ED00, 0xEB2D6E20, 0x305C6860, 0xDDE4EB40, 0xB020F240, 0x5D987160, 0x86E97720, 0x6B51F400, 0xDDB3F880, 0x300B7BA0, 0xEB7A7DE0, 0x06C2FEC0,
	        0x30F24FE0, 0xDD4ACCC0, 0x063BCA80, 0xEB8349A0, 0x5D614520, 0xB0D9C600, 0x6BA8C040, 0x86104360, 0xEBD45A60, 0x066CD940, 0xDD1DDF00, 0x30A55C20, 0x864750A0, 0x6BFFD380, 0xB08ED5C0, 0x5D3656E0,
	        0xDCEFB780, 0x315734A0, 0xEA2632E0, 0x079EB1C0, 0xB17CBD40, 0x5CC43E60, 0x87B53820, 0x6A0DBB00, 0x07C9A200, 0xEA712120, 0x31002760, 0xDCB8A440, 0x6A5AA8C0, 0x87E22BE0, 0x5C932DA0, 0xB12BAE80,
	        0x871B1FA0, 0x6AA39C80, 0xB1D29AC0, 0x5C6A19E0, 0xEA881560, 0x07309640, 0xDC419000, 0x31F91320, 0x5C3D0A20, 0xB1858900, 0x6AF48F40, 0x874C0C60, 0x31AE00E0, 0xDC1683C0, 0x07678580, 0xEADF06A0
        };


        static uint crc(string s)
        {
            uint crcsum = 0xFFFFFFFF;

            for (int i = 0; i < s.Length; i++)
            {
                byte c = (byte)s[i];
                c ^= (byte)(crcsum & 0xFF);
                crcsum = crc_table[c] ^ (crcsum >> 8);
            }
            return crcsum;
        }

        void ShowLicense(uint id, ulong data)
        {
            Cursor = Cursors.Default;
            MainClass.PkData = data;
            AssemblyName assemblyName = Program.AssemblyToActivate.GetName();
            string HashedName;
            string ProductName;
            if ((data & 0x40) != 0)
            {
                HashedName = string.Format("{0}", assemblyName.Name);
                ProductName = Program.ProductName;
            }
            else if ((data & 0x20)!=0)
            {
                HashedName = string.Format("{0} v{1}.x", assemblyName.Name, assemblyName.Version.Major);
                ProductName = string.Format("{0} v{1}.x", Program.ProductName, assemblyName.Version.Major);
            }
            else
            {
                HashedName = string.Format("{0} v{1}.{2}", assemblyName.Name, assemblyName.Version.Major, assemblyName.Version.Minor);
                ProductName = string.Format("{0} v{1}.{2}", Program.ProductName, assemblyName.Version.Major, assemblyName.Version.Minor);
            }
            uint hash = crc(HashedName);
            if(hash != ((data >> 32) & 0xFFFFFFFF))
            {
                tbMessage.Text = "*" + Resources.KeyNoMatch;
                button1.Enabled = true;
                Suivant.Enabled = false;
                return;
            }
            ProductName += string.Format(" -  {0}", (MainClass.PkSubscription) ? Resources.Subscription : Resources.License);
            if (MainClass.PkMultiKind != 0)
            {
                //if (string.IsNullOrEmpty(MainClass.serverAddress))
                //{
                //    MessageBox.Show(this, Resources.ServerNeeded, Program.WizardTitle);
                //    button1.Enabled = true;
                //    Suivant.Enabled = false;
                //    return;
                //}
                switch (MainClass.PkMultiKind)
                {
                    case 0x10: ProductName += string.Format(" - {0}", Resources.Site); break;
                    case 0x02:
                    case 0x80: ProductName += " -"+string.Format(Resources.Devices, MainClass.PkMultiCount); break;
                    case 0x01:
                    case 0x40: ProductName += " -" + string.Format(Resources.Users, MainClass.PkMultiCount); break;
                    default:   ProductName += " -" + string.Format(Resources.DevicesUsers, MainClass.PkMultiCount); break;
                }
            }
            MainClass.ProductKey = ProductKey;
            tbMessage.Text = ProductName;
            button1.Enabled = true;
            Suivant.Enabled = true;
        }

        void GetInfos()
        {
            ulong LicenseData = ActivationManager.GetProductkeyData(ProductKey);
            uint LicenseId = ActivationManager.GetLicenseId(ProductKey);
            Invoke(new ShowLicenseDelegate(ShowLicense), LicenseId, LicenseData);
        }

		private void Suivant_Click(object sender, System.EventArgs e)
		{
            ProductKey = Key1.Text;
            if (tbMessage.Text.Length == 0)
            {
                button1.Enabled = Suivant.Enabled = false;
                Cursor = Cursors.WaitCursor;
                ThreadStart ThreadFunc = new ThreadStart(GetInfos);
                theThread = new Thread(ThreadFunc);
                theThread.Start();
                return;
            }
            
			wzAction=2;
			Close();
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			wzAction=0;
			Close();
		}

        private void Key_TextChanged(object sender, EventArgs e)
        {
            tbMessage.Text = "";
            Suivant.Enabled = Key1.Text.Length == 29;
        }

        private void Precedent_Click_1(object sender, EventArgs e)
        {
            wzAction = 1;
            Close();
        }

	}
}
