using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Security.Cryptography;

using PvLogiciels.dotNetProtector;

namespace Wizard
{
	/// <summary>
	/// Description rsume de WizardKey.
	/// </summary>
	internal class WizardUSB : System.Windows.Forms.Form
	{
		public int wzAction;
        public string stLicence;
		private System.Windows.Forms.Button Suivant;
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button Precedent;
        private System.Windows.Forms.Label label2;
        private TextBox tbMessage;
        private Button btStartDetect;
        private Button btFindDevice;
        private Label lblStart;
        private Label lblNotFound;
        private Label lblFound;
        private System.Windows.Forms.Button Cancel;

        internal UsbDetector detector = null;

		public WizardUSB()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();
            Text = Program.WizardTitle;

		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(WizardUSB));
            this.Suivant = new System.Windows.Forms.Button();
            this.Precedent = new System.Windows.Forms.Button();
            this.label2 = new System.Windows.Forms.Label();
            this.Cancel = new System.Windows.Forms.Button();
            this.tbMessage = new System.Windows.Forms.TextBox();
            this.btStartDetect = new System.Windows.Forms.Button();
            this.btFindDevice = new System.Windows.Forms.Button();
            this.lblStart = new System.Windows.Forms.Label();
            this.lblNotFound = new System.Windows.Forms.Label();
            this.lblFound = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // Suivant
            // 
            this.Suivant.DialogResult = System.Windows.Forms.DialogResult.OK;
            resources.ApplyResources(this.Suivant, "Suivant");
            this.Suivant.Name = "Suivant";
            this.Suivant.Click += new System.EventHandler(this.Suivant_Click);
            // 
            // Precedent
            // 
            this.Precedent.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            resources.ApplyResources(this.Precedent, "Precedent");
            this.Precedent.Name = "Precedent";
            this.Precedent.Click += new System.EventHandler(this.Precedent_Click);
            // 
            // label2
            // 
            resources.ApplyResources(this.label2, "label2");
            this.label2.Name = "label2";
            // 
            // Cancel
            // 
            this.Cancel.DialogResult = System.Windows.Forms.DialogResult.Abort;
            resources.ApplyResources(this.Cancel, "Cancel");
            this.Cancel.Name = "Cancel";
            this.Cancel.Click += new System.EventHandler(this.Cancel_Click);
            // 
            // tbMessage
            // 
            this.tbMessage.BorderStyle = System.Windows.Forms.BorderStyle.None;
            resources.ApplyResources(this.tbMessage, "tbMessage");
            this.tbMessage.Name = "tbMessage";
            this.tbMessage.ReadOnly = true;
            this.tbMessage.TabStop = false;
            // 
            // btStartDetect
            // 
            resources.ApplyResources(this.btStartDetect, "btStartDetect");
            this.btStartDetect.Name = "btStartDetect";
            this.btStartDetect.UseVisualStyleBackColor = true;
            this.btStartDetect.Click += new System.EventHandler(this.btStartDetect_Click);
            // 
            // btFindDevice
            // 
            resources.ApplyResources(this.btFindDevice, "btFindDevice");
            this.btFindDevice.Name = "btFindDevice";
            this.btFindDevice.UseVisualStyleBackColor = true;
            this.btFindDevice.Click += new System.EventHandler(this.btFindDevice_Click);
            // 
            // lblStart
            // 
            resources.ApplyResources(this.lblStart, "lblStart");
            this.lblStart.Name = "lblStart";
            // 
            // lblNotFound
            // 
            resources.ApplyResources(this.lblNotFound, "lblNotFound");
            this.lblNotFound.Name = "lblNotFound";
            // 
            // lblFound
            // 
            resources.ApplyResources(this.lblFound, "lblFound");
            this.lblFound.Name = "lblFound";
            // 
            // WizardUSB
            // 
            resources.ApplyResources(this, "$this");
            this.Controls.Add(this.lblFound);
            this.Controls.Add(this.lblNotFound);
            this.Controls.Add(this.lblStart);
            this.Controls.Add(this.btFindDevice);
            this.Controls.Add(this.btStartDetect);
            this.Controls.Add(this.tbMessage);
            this.Controls.Add(this.Cancel);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.Precedent);
            this.Controls.Add(this.Suivant);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "WizardUSB";
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void Precedent_Click(object sender, System.EventArgs e)
		{
            wzAction = 1;
			Close();
		}

		private void Suivant_Click(object sender, System.EventArgs e)
		{
			wzAction=2;
			Close();
		}

		private void Cancel_Click(object sender, System.EventArgs e)
		{
			wzAction=0;
			Close();
		}

        private void btStartDetect_Click(object sender, EventArgs e)
        {
            detector = new UsbDetector();
            tbMessage.Text = lblStart.Text;
            btStartDetect.Enabled = false;
            btFindDevice.Enabled = true;
        }

        private void btFindDevice_Click(object sender, EventArgs e)
        {
            if (detector == null) return;
            btFindDevice.Enabled = false;
            detector.Detect();
            btFindDevice.Enabled = false;
            if (detector.FoundDevice.Length > 0)
            {
                tbMessage.Text = string.Format(lblFound.Text, detector.FoundDevice);
                Suivant.Enabled = true;
            }
            else
            {
                tbMessage.Text = lblNotFound.Text;
                btStartDetect.Enabled = true;
            }
        }

	}
}
