﻿namespace Wizard
{
    using System;

    internal class Resources {

        
        private static PvLogiciels.dotNetProtector.ResourceManager resourceMan;

        internal static PvLogiciels.dotNetProtector.ResourceManager ResourceManager
        {
            get
            {
                if (object.ReferenceEquals(resourceMan, null))
                {
                    PvLogiciels.dotNetProtector.ResourceManager temp = new global::PvLogiciels.dotNetProtector.ResourceManager(typeof(Resources));
                    resourceMan = temp;
                }
                return resourceMan;
            }
        }
        /*
        private static global::System.Resources.ResourceManager resourceMan;

        internal static global::System.Resources.ResourceManager ResourceManager
        {
            get
            {
                if (object.ReferenceEquals(resourceMan, null))
                {
                    global::System.Resources.ResourceManager temp = new global::System.Resources.ResourceManager(typeof(Resources));
                    resourceMan = temp;
                }
                return resourceMan;
            }
        }
        */

        internal static string ActivationError { get { return ResourceManager.GetString("ActivationError"); } }
        internal static string ActivationMessages { get { return ResourceManager.GetString("ActivationMessages"); } }
        internal static string ActivationOk { get { return ResourceManager.GetString("ActivationOk"); } }
        internal static string ErrorText { get { return ResourceManager.GetString("ErrorText"); } }
        internal static string ExeFilter { get { return ResourceManager.GetString("ExeFilter"); } }
        internal static string InvalidKey { get { return ResourceManager.GetString("InvalidKey"); } }
        internal static string OpenTitle { get { return ResourceManager.GetString("OpenTitle"); } }
        internal static string ServerReponse { get { return ResourceManager.GetString("ServerReponse"); } }
        internal static string UnKnownError { get { return ResourceManager.GetString("UnKnownError"); } }
        internal static string WizardTitleFormat { get { return ResourceManager.GetString("WizardTitleFormat"); } }
        internal static string LocalKinds { get { return ResourceManager.GetString("LocalKinds"); } }
        internal static string NetKinds { get { return ResourceManager.GetString("NetKinds"); } }
        internal static string KeyNoMatch { get { return ResourceManager.GetString("KeyNoMatch"); } }
        internal static string License { get { return ResourceManager.GetString("License"); } }
        internal static string Subscription { get { return ResourceManager.GetString("Subscription"); } }
        internal static string Devices { get { return ResourceManager.GetString("Devices"); } }
        internal static string Users { get { return ResourceManager.GetString("Users"); } }
        internal static string Site { get { return ResourceManager.GetString("Site"); } }
        internal static string DevicesUsers { get { return ResourceManager.GetString("DevicesUsers"); } }
        internal static string ServerNeeded { get { return ResourceManager.GetString("ServerNeeded"); } }
        internal static string TxtInstant { get { return ResourceManager.GetString("TxtInstant"); } }
    }
}
