using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Wizard
{
	/// <summary>
	/// Description rsume de Wizard1.
	/// </summary>
	internal class WizardServer : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button Suivant;
		public int wzAction;
		private System.Windows.Forms.Button Annuler;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Button Precedent;
        private TextBox txtServer;
        private Label textBox1;
        internal CheckBox cbSiteLic;
        private Button btTest;
        private ImageList imageList1;
        private IContainer components;
        string txtTest;

		public WizardServer()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

            txtTest = btTest.Text;
            Text = Program.WizardTitle;
            //MainClass.siteLicense = true;
			wzAction = 0;
            cbSiteLic.Visible = false;
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Code gnr par le Concepteur Windows Form
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            //System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(WizardServer));
            PvLogiciels.dotNetProtector.ComponentResourceManager resources = new PvLogiciels.dotNetProtector.ComponentResourceManager(typeof(WizardServer));
            this.Suivant = new System.Windows.Forms.Button();
            this.Annuler = new System.Windows.Forms.Button();
            this.label4 = new System.Windows.Forms.Label();
            this.Precedent = new System.Windows.Forms.Button();
            this.txtServer = new System.Windows.Forms.TextBox();
            this.textBox1 = new System.Windows.Forms.Label();
            this.cbSiteLic = new System.Windows.Forms.CheckBox();
            this.btTest = new System.Windows.Forms.Button();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.SuspendLayout();
            // 
            // Suivant
            // 
            this.Suivant.DialogResult = System.Windows.Forms.DialogResult.OK;
            resources.ApplyResources(this.Suivant, "Suivant");
            this.Suivant.Name = "Suivant";
            this.Suivant.Click += new System.EventHandler(this.Suivant_Click);
            // 
            // Annuler
            // 
            this.Annuler.DialogResult = System.Windows.Forms.DialogResult.Abort;
            resources.ApplyResources(this.Annuler, "Annuler");
            this.Annuler.Name = "Annuler";
            this.Annuler.Click += new System.EventHandler(this.Annuler_Click);
            // 
            // label4
            // 
            resources.ApplyResources(this.label4, "label4");
            this.label4.Name = "label4";
            // 
            // Precedent
            // 
            this.Precedent.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            resources.ApplyResources(this.Precedent, "Precedent");
            this.Precedent.Name = "Precedent";
            this.Precedent.Click += new System.EventHandler(this.Precedent_Click);
            // 
            // txtServer
            // 
            resources.ApplyResources(this.txtServer, "txtServer");
            this.txtServer.Name = "txtServer";
            this.txtServer.TextChanged += new System.EventHandler(this.txtServer_TextChanged);
            // 
            // textBox1
            // 
            resources.ApplyResources(this.textBox1, "textBox1");
            this.textBox1.Name = "textBox1";
            // 
            // cbSiteLic
            // 
            resources.ApplyResources(this.cbSiteLic, "cbSiteLic");
            this.cbSiteLic.Name = "cbSiteLic";
            this.cbSiteLic.UseVisualStyleBackColor = true;
            // 
            // btTest
            // 
            this.btTest.ImageList = this.imageList1;
            resources.ApplyResources(this.btTest, "btTest");
            this.btTest.Name = "btTest";
            this.btTest.UseVisualStyleBackColor = true;
            this.btTest.Click += new System.EventHandler(this.btTest_Click);
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList1.Images.SetKeyName(0, "Ok.png");
            this.imageList1.Images.SetKeyName(1, "Error.png");
            // 
            // WizardServer
            // 
            resources.ApplyResources(this, "$this");
            this.Controls.Add(this.btTest);
            this.Controls.Add(this.cbSiteLic);
            this.Controls.Add(this.textBox1);
            this.Controls.Add(this.txtServer);
            this.Controls.Add(this.Precedent);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.Annuler);
            this.Controls.Add(this.Suivant);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "WizardServer";
            this.TopMost = true;
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		private void Suivant_Click(object sender, System.EventArgs e)
		{
            MainClass.serverAddress = txtServer.Text;
            MainClass.cbSiteLicChecked = cbSiteLic.Checked;
			wzAction=2;
			Close();
		}

        void Ping()
        {
            bool result = PvLogiciels.dotNetProtector.ActivationManager.PingLicenseServer(txtServer.Text);
            if (result)
            {
                btTest.ImageIndex = 0;
                btTest.Text = "";
            }
            else
            {
                btTest.ImageIndex = 1;
                btTest.Text = "";
            }
        }

		private void Annuler_Click(object sender, System.EventArgs e)
		{
			wzAction = 0;
			Close();
		}

		private void Precedent_Click(object sender, System.EventArgs e)
		{
			wzAction = 1;
			Close();
		}

        private void txtServer_TextChanged(object sender, EventArgs e)
        {
            btTest.Text = txtTest;
            btTest.ImageIndex = -1;
        }

        private void btTest_Click(object sender, EventArgs e)
        {
            Ping();
        }
	}
}
